<template>
  <span class="icon" ref="icon" v-html="icon.toSvg(options)"></span>
</template>

<script>
import feather from 'feather-icons'

export default {
  name: 'icon',

  inheritAttrs: false,

  props: {
    name: {
      type: String,
      required: true
    },
    width: {
      type: [Number, String],
      default: 24
    },
    height: {
      type: [Number, String],
      default: 24
    },
    square: {
      type: [Boolean, Number, String],
      default: false
    },
    strokeWidth: {
      type: Number,
      default: 2
    }
  },

  watch: {
    name: 'replace',
    // width: 'replace',
    // height: 'replace',
    square: 'replace',
    strokeWidth: 'replace'
  },

  computed: {
    iconName () {
      for (const icon of Object.keys(feather.icons)) {
        if (feather.icons[icon].tags.includes(this.name)) {
          return icon
        }
      }

      // Fallback to default 'square' if icon name doesn't and add warning
      if (!feather.icons.hasOwnProperty(this.name)) {
        console.warn(`Icon name "${this.name}" doesn't exist, fallback to "square" icon.`)

        return 'square'
      }

      return this.name
    },

    options () {
      const options = {
        width: this.width,
        height: this.height,
        'stroke-width': this.strokeWidth
        // class: this.$refs.icon.classList.toString()
      }

      if (this.square) {
        if (typeof this.square !== 'boolean') {
          options.width = this.square
        }
        options.height = options.width
      }

      return options
    },

    icon () {
      return feather.icons[this.iconName]
    }
  },

  methods: {
    replace () {
      feather.replace(this.options)
    }
  },

  mounted () {
    this.replace()
  }
}
</script>

<style lang="scss" scoped>
.icon {
  display: inline-block;
  line-height: 1;
}
</style>
